package com.tin.etabf.filecreator;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

import com.tin.etbaf.rpu.GRPU;
import com.tin.etbaf.rpu.GRPUMain;
import com.tin.etbaf.rpu.GRPUTableCellEditorTDSValue;

public class CreateFile {

	private GRPU rpu = null;
	DefaultTableModel model = null;
	DefaultTableModel model1 = null;
	DefaultTableModel model2 = null;
	GRPUMain grpumain = null;
	CorrValidation corrval = null; // ## Newly changed for correction Ver1.2
	//String correctiontype = "##"; // ## Newly changed for correction Ver1.2 by Akansha
	private void initialize() {

		rpu.retrievedFormValues();
		rpu.retrievedChallanValues();
		//rpu.retrievedAnnIValues();
		if (rpu.formNumber.equalsIgnoreCase("24Q"))
			rpu.retrievedAnnIIValues(); // --- form = 24Q and Q4

	}

	public CreateFile(GRPU rpu, DefaultTableModel passedModel,
			DefaultTableModel passedModel1, DefaultTableModel passedModel2,GRPUMain passedMain) {
		// TODO Auto-generated constructor stub
		this.rpu = rpu;
		model = passedModel;
		model1 = passedModel1;
		model2 = passedModel2;
		grpumain = passedMain;
		corrval = new CorrValidation();
		initialize();
	}

	public void createRegular() {
		boolean retFlag = false;

		FileAppender FA = new FileAppender(rpu, model, model1, model2);

		StringBuilder sb = new StringBuilder();
		ArrayList<Object> ls = new ArrayList<Object>();

		// Saving Values in BEAN -- FH Regular //

		FHBean fh = FA._FHAppenderRegular();

		// FH creation ENDS

		/*sb.append(fh);
		sb.append("\n");*/
		ls.add(fh);

		//System.out.println("Only FH String : " + sb);

		// Saving Values in BEAN -- BH == Start //

		//BHBean bh = FA._BHAppender(sb, "R");
		int bhCounter = 1;
		BHBean bh = FA._BHAppender(ls,bhCounter, "R");

		// Saving Values in BEAN -- BH == END //

		/*sb.append(bh);
		sb.append("\n");*/
		ls.add(bh);
	//	System.out.println("Only BH String : " + bh.toString());

		// Generating Challan Details -- CD == Start //

		int challancount = new Integer(rpu.ChallanCount) + 1;
		CDBean cd = null;

		for (int i = 2; i <= challancount; i++) {
			//cd = FA._CDAppender(sb, i);
			cd = FA._CDAppender(ls,bhCounter, i);

			//System.out.println("Only CD Strings : " + cd.toString());

			/*sb.append(cd);
			sb.append("\n");*/
			ls.add(cd);
			// Start of DD Record for a particular CD //

			for (Integer inneri : FA.li) {

				DDBean dd;

/*				Integer DDCount = new Integer(model1.getRowCount() - 2);

				DDCount = DDCount + 1;*/
				//dd = FA._DDAppender(sb, inneri, cd);

				dd = FA._DDAppender(ls,bhCounter, inneri, cd);

				//System.out.println("Only DD Strings : " + dd.toString());

				/*sb.append(dd);
				sb.append("\n");*/
				ls.add(dd);
				// End of DD Record for a particular CD.
			}

			/*
			 * cd.setTDSTCSIncomeTax(""); cd.setTDSTCSCess("");
			 * cd.setTDSTCSSurcharge("");
			 */

		}

		// Generating Salary Details -- SD == START //

		if (rpu.formNumber.equalsIgnoreCase("24Q")
				&& rpu.quarter.equalsIgnoreCase("Q4")) {

			SDBean sd = null;

			Integer SalaryCount = (new Integer(model2.getRowCount() - 2));

			SalaryCount = SalaryCount + 1;

			for (int i = 2; i <= SalaryCount; i++) {
				//int c6a=0;
				//sd = FA._SDAppender(sb, i);
				sd = FA._SDAppender(ls,bhCounter, i);

				/*sb.append(sd);

				sb.append("\n");*/
				ls.add(sd);			
				System.out.println("HI c6ACount is " + FA.c6ACount);
				
				int serialnumber = 0;

				for (Integer inneri : FA.S16Count) {
					serialnumber++;
					
					//S16Bean s16 = FA._S16Appender(sb, sd, inneri, i,serialnumber);
					S16Bean s16 = FA._S16Appender(ls, bhCounter, sd, inneri, i,serialnumber);

					/*sb.append(s16);

					sb.append("\n");*/
					ls.add(s16);

				}

				serialnumber = 0;
				
				//RPU 2.9 start
				C6ABean c6A = null;
				
				FA.c6ACount_counter=0;FA.c6aString_counter=0;
					for(FA.c6aString_counter=0;(FA.c6aString_counter<FA.c6aString.length && FA.c6ACount_counter<FA.c6ACount.size());FA.c6aString_counter++)
					{
						serialnumber++;										
						c6A = FA._C6Appender(ls, bhCounter, sd, i, serialnumber);	

						if (!(
								(          (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals(""))
										&& (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))
										&& (c6A.getQuaamountunderChapterVIA().equals("0.00") || c6A.getQuaamountunderChapterVIA().equals(""))
										)						// to handle others,80G,80TTA ka all 3 "0.00" values
										|| (     
												(c6A.getChapterVIASectionID().equals("80CCG")        && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
												|| (c6A.getChapterVIASectionID().equals("80CCE") && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
												|| (c6A.getChapterVIASectionID().equals("80CCF") && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
												)              // to handle 80CCG,80CCE,80CCF ka only deductable "0.00" values  
												||(
														(c6A.getChapterVIASectionID().equals("80C")          && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCC")     && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCD(1)")  && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCD(1B)") && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCD(2)")  && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80D")       && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80E")       && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														)        // to handle remaining... only ded,grs "0.00" values  

								)
								)
						ls.add(c6A);
						else 
							serialnumber--;
					}																							
					//RPU 2.9 end
			}

		}

		// Generating Salary Details -- SD == END //


		try{
			//System.out.println("I am in.. create file button event");
			//Temp code
			//new development for FRD1.3 by Akansha
			 File f = new File(grpumain.filename);
			// System.out.println(f.exists());

			 if(f.exists()){
				  //showCreateFileDialog(ls,false,"R");
				 /*********************************************************************************************************/
				 	//Added by Sadhana FRD2.0
				 if(!rpu.formNumber.equals("24Q")){
					 int createFileCount = 0, updatedRec = 0;
						int ddRowCount = model1.getRowCount();
						int selYear_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4));
						int next_year_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(5, 9));
						Object col17;
						Object col21;
						Object col28Or29 = null; 
						Object col31Or40 = null; 
						Double calculatedValue = null;
						String strChangeColor = "";
						int j;
						if(ddRowCount > 2){
							for (j = 2; j < ddRowCount; j++) {
								col31Or40 = null; 
								/*System.out.println("F status check :"+rpu.strAnnexIColValue);
								System.out.println("value form string :"+rpu.strAnnexIColValue.charAt(j - 2));*/
								/*if(rpu.valueOfTypeOfStmt.equalsIgnoreCase("Correction") && rpu.strAnnexIColValue.charAt(j - 2) == 'F'){
									strChangeColor += "N";
								}else{
									col17 = model1.getValueAt(j, 17);
									col21 = model1.getValueAt(j, 21);
									if(rpu.formNumber.equals("26Q") || rpu.formNumber.equals("27Q")){
										col28Or29 = model1.getValueAt(j, 28);
									}else if(rpu.formNumber.equals("27EQ")){
										col28Or29 = model1.getValueAt(j, 29);
									}
									
									calculatedValue = (Double.parseDouble(col17.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
									if(Double.parseDouble(col21.toString()) < calculatedValue){
										createFileCount++;
										strChangeColor += "Y";
									}else{
										strChangeColor += "N";
									}
								}*/
								col17 = model1.getValueAt(j, 17);
								col21 = model1.getValueAt(j, 21);
								if(rpu.formNumber.equals("26Q") || rpu.formNumber.equals("27Q")){
									col28Or29 = model1.getValueAt(j, 28);
								}else if(rpu.formNumber.equals("27EQ")){
									col28Or29 = model1.getValueAt(j, 29);
								}
								
								//rpu 3.1 start calculation of total tds
								
								if(rpu.formNumber.equals("26Q") ){
									if(model1.getValueAt(j, 31) !=	null && !"".equals(model1.getValueAt(j, 31)))
									{
										//System.out.println("TDs value "+model1.getValueAt(j, 31).equals(null)+"31 ka value "+model1.getValueAt(j, 31));
									col31Or40 = model1.getValueAt(j, 31);
									}
								}else if(rpu.formNumber.equals("27Q")){
									if(model1.getValueAt(j, 40) !=	null && !"".equals(model1.getValueAt(j, 40)))
									{
									col31Or40 = model1.getValueAt(j, 40);
									}
								}
								
								if(col31Or40 !=null)
								{
									calculatedValue = (Double.parseDouble(col31Or40.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
									}
								else
								calculatedValue = (Double.parseDouble(col17.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
								if(!(model1.getValueAt(j, 6).equals("4NF"))) //RPU 3.4 Observation fix
								if(Double.parseDouble(col21.toString()) < calculatedValue){
									createFileCount++;
									strChangeColor += "Y";
									updatedRec = j;
								}else{
									strChangeColor += "N";
								}
							}
							if(createFileCount > 0){
								rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
								JOptionPane.showMessageDialog(null,"Total TDS/TCS amount mentioned for deductees/collectees are not as per rate of deduction provided in the statement. Same are marked in red color.");
								rpu.pointToCell_Annex1(updatedRec, 18);
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(17)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(18)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(19)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
							}else{
								rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(17)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(18)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(19)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								showCreateFileDialog(ls,false,"R");
							}
						}else{
							showCreateFileDialog(ls,false,"R");
						}
				 }else{
					 showCreateFileDialog(ls,false,"R");
				 }
				 /*********************************************************************************************************/
			  }else{
				  //showCreateFileDialog(ls,true,"R"); //commented after implementing kunal code....
				  /*********************************************************************************************************/
				 	//Added by Sadhana FRD2.0
				 if(!rpu.formNumber.equals("24Q")){
					 int createFileCount = 0, updatedRec = 0 ;
						int ddRowCount = model1.getRowCount();
						int selYear_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4));
						int next_year_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(5, 9));
						Object col17;
						Object col21;
						Object col28Or29 = null; 
						Object col31Or40 = null;
						Double calculatedValue = null;
						String strChangeColor = "";
						int j;
						if(ddRowCount > 2){
							for (j = 2; j < ddRowCount; j++) {
								col31Or40 = null;
								/*System.out.println("F status check :"+rpu.strAnnexIColValue);
								System.out.println("value form string :"+rpu.strAnnexIColValue.charAt(j - 2));*/
								/*if(rpu.valueOfTypeOfStmt.equalsIgnoreCase("Correction") && rpu.strAnnexIColValue.charAt(j - 2) == 'F'){
									strChangeColor += "N";
								}else{
									col17 = model1.getValueAt(j, 17);
									col21 = model1.getValueAt(j, 21);
									if(rpu.formNumber.equals("26Q") || rpu.formNumber.equals("27Q")){
										col28Or29 = model1.getValueAt(j, 28);
									}else if(rpu.formNumber.equals("27EQ")){
										col28Or29 = model1.getValueAt(j, 29);
									}
									
									calculatedValue = (Double.parseDouble(col17.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
									if(Double.parseDouble(col21.toString()) < calculatedValue){
										createFileCount++;
										strChangeColor += "Y";
									}else{
										strChangeColor += "N";
									}
								}*/
								col17 = model1.getValueAt(j, 17);
								col21 = model1.getValueAt(j, 21);
								if(rpu.formNumber.equals("26Q") || rpu.formNumber.equals("27Q")){
									col28Or29 = model1.getValueAt(j, 28);
								}else if(rpu.formNumber.equals("27EQ")){
									col28Or29 = model1.getValueAt(j, 29);
								}
//rpu 3.1 start calculation of total tds
								
								
								if(rpu.formNumber.equals("26Q") ){
									if(model1.getValueAt(j, 31) !=	null && !"".equals(model1.getValueAt(j, 31)))
									{
										//System.out.println("TDs value "+model1.getValueAt(j, 31).equals(null)+"31 ka value "+model1.getValueAt(j, 31));
									col31Or40 = model1.getValueAt(j, 31);
									}
								}else if(rpu.formNumber.equals("27Q")){
									if(model1.getValueAt(j, 40) !=	null && !"".equals(model1.getValueAt(j, 40)))
									{
									col31Or40 = model1.getValueAt(j, 40);
									}
								}
								
								if(col31Or40 != null)
								{
									calculatedValue = (Double.parseDouble(col31Or40.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
								}
								else
								calculatedValue = (Double.parseDouble(col17.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
								if(!(model1.getValueAt(j, 6).equals("4NF"))) //RPU 3.4 Observation fix
								if(Double.parseDouble(col21.toString()) < calculatedValue){
									createFileCount++;
									strChangeColor += "Y";
									updatedRec = j;
								}else{
									strChangeColor += "N";
								}
							}
							if(createFileCount > 0){
								rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
								JOptionPane.showMessageDialog(null,"Total TDS/TCS amount mentioned for deductees/collectees are not as per rate of deduction provided in the statement. Same are marked in red color.");
								rpu.pointToCell_Annex1(updatedRec, 18);
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(17)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(18)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(19)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
							}else{
								rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(17)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(18)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));
								rpu.jTableTransacDetails1
								.getColumnModel()
								.getColumn(19)
								.setCellRenderer(
										new GRPUTableCellEditorTDSValue(
												"Anne1", selYear_ann1_colour,
												next_year_ann1_colour, rpu.formNumber,
												true, strChangeColor,false));

								showCreateFileDialog(ls,true,"R"); //commented after implementing kunal code....
							}
						}else{
							showCreateFileDialog(ls,true,"R");
						}
				 }else{
					 showCreateFileDialog(ls,true,"R"); //commented after implementing kunal code....
				 }
				 /*********************************************************************************************************/
			  }
			}catch(Exception e1 ){
				//System.out.println("I am the fool");
				e1.printStackTrace();
			}
			//************************************
	
	
		//showCreateFileDialog(sb);
		

	}

	
	//################################################################# CORRECTION STRING ###############################################################################

	Boolean CorrectionFlag = false;
	Integer BH_Count = 0;
	public void createCorrection() {
		
		FileAppender FA = new FileAppender(rpu, model, model1, model2);
		ArrayList<Object> ls = new ArrayList<Object>();
		ArrayList<Object> ls1 = new ArrayList<Object>();
		

		/*StringBuilder sb = new StringBuilder();
		StringBuilder sb1 = new StringBuilder();*/

		ls1 = EvaluateCorrectionType(FA);
		ls1.remove(0);

		// Saving Values in BEAN -- FH Regular //

		FHBean fh = FA._FHAppenderCorrection(BH_Count);

		// FH creation ENDS

		ls.add(fh);
		// sb.append("\n");

		ls.addAll(ls1);
		
		
	//	System.out.println("And the NEW Correction String is " );
		if(CorrectionFlag && !corrIsError)
		{
			try{
				//System.out.println("I am in.. create file button event");
				//Temp code
				//new development for FRD1.3 by Akansha
				 File f = new File(grpumain.filename);
				// System.out.println(f.exists());

				 if(f.exists()){
					  //showCreateFileDialog(ls,false,"C");
					 
					 /*********************************************************************************************************/
					 	//Added by Sadhana FRD2.0
					 if(!rpu.formNumber.equals("24Q")){
						 int createFileCount = 0, updatedRec = 0;
							int ddRowCount = model1.getRowCount();
							int selYear_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4));
							int next_year_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(5, 9));
							Object col17;
							Object col21;
							Object col28Or29 = null; 
							Object col31Or40 = null; 
							Double calculatedValue = null;
							String strChangeColor = "";
							int j;
							if(ddRowCount > 2){
								for (j = 2; j < ddRowCount; j++) {
									
									String mode = "";
									Object modeObj = model1.getValueAt(j, 2);
									if (modeObj != null)
										mode = modeObj.toString();
									System.out.println("mode of row ="+mode);
									
								
									System.out.println("value form string :"+rpu.strAnnexIColValue.charAt(j - 2));
									if(rpu.valueOfTypeOfStmt.equalsIgnoreCase("Correction") && rpu.strAnnexIColValue.charAt(j - 2) == 'F'){
										strChangeColor += "N";
									}else if(rpu.valueOfTypeOfStmt.equalsIgnoreCase("Correction") && (mode.equalsIgnoreCase("--Select--") || mode.equalsIgnoreCase("PAN UPDATE"))){
										strChangeColor += "N";
									}else{
										col17 = model1.getValueAt(j, 17);
										col21 = model1.getValueAt(j, 21);
										if(rpu.formNumber.equals("26Q") || rpu.formNumber.equals("27Q")){
											col28Or29 = model1.getValueAt(j, 28);
										}else if(rpu.formNumber.equals("27EQ")){
											col28Or29 = model1.getValueAt(j, 29);
										}
										
										//rpu 3.1 start calculation of total tds																													
										if(rpu.formNumber.equals("26Q") ){
											if(model1.getValueAt(j, 31) !=	null && !"".equals(model1.getValueAt(j, 31)))
											{
													col31Or40 = model1.getValueAt(j, 31);
											}
										}else if(rpu.formNumber.equals("27Q")){
											if(model1.getValueAt(j, 40) !=	null && !"".equals(model1.getValueAt(j, 40)))
											{
											col31Or40 = model1.getValueAt(j, 40);
											}
										}
										
										if(col31Or40 != null)
										{
											calculatedValue = (Double.parseDouble(col31Or40.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
											System.out.println("calculated value "+calculatedValue);
										}
										else					
										calculatedValue = (Double.parseDouble(col17.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
										if(!(model1.getValueAt(j, 6).equals("4NF"))) //RPU 3.4 Observation fix
										if(Double.parseDouble(col21.toString()) < calculatedValue){
											createFileCount++;
											strChangeColor += "Y";
											updatedRec = j;
										}else{
											strChangeColor += "N";
										}
									}
								}
								if(createFileCount > 0){
									rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
									JOptionPane.showMessageDialog(null,"Total TDS/TCS amount mentioned for deductees/collectees are not as per rate of deduction provided in the statement. Same are marked in red color.");
									rpu.pointToCell_Annex1(updatedRec, 19);
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(17)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(18)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(19)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
								}else{
									rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(17)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(18)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(19)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									showCreateFileDialog(ls,false,"C");
								}
							}else{
								showCreateFileDialog(ls,false,"C");
							}
					 }else{
						 showCreateFileDialog(ls,false,"C");
					 }
					 /*********************************************************************************************************/
				  }else{
					  
					  /*System.out.println("File not found!");
					  showCreateFileDialog(ls,true,"C"); //commented after implementing kunal code....*/		
					  /*********************************************************************************************************/
					 	//Added by Sadhana FRD2.0
					 if(!rpu.formNumber.equals("24Q")){
						 int createFileCount = 0, updatedRec = 0;
							int ddRowCount = model1.getRowCount();
							int selYear_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4));
							int next_year_ann1_colour = Integer.parseInt(rpu.JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(5, 9));
							Object col17;
							Object col21;
							Object col28Or29 = null; 
							Object col31Or40 = null; 
							Double calculatedValue = null;
							String strChangeColor = "";
							int j;
							if(ddRowCount > 2){
								for (j = 2; j < ddRowCount; j++) {
									
									String mode = "";
									Object modeObj = model1.getValueAt(j, 2);
									if (modeObj != null)
										mode = modeObj.toString();
									System.out.println("mode of row ="+mode);
									
									
									//System.out.println("value form string :"+rpu.strAnnexIColValue.charAt(j - 2));
									/*if(rpu.valueOfTypeOfStmt.equalsIgnoreCase("Correction") && rpu.strAnnexIColValue.charAt(j - 2) == 'F'){
										strChangeColor += "N";
									}else{
										col17 = model1.getValueAt(j, 17);
										col21 = model1.getValueAt(j, 21);
										if(rpu.formNumber.equals("26Q") || rpu.formNumber.equals("27Q")){
											col28Or29 = model1.getValueAt(j, 28);
										}else if(rpu.formNumber.equals("27EQ")){
											col28Or29 = model1.getValueAt(j, 29);
										}
										
										calculatedValue = (Double.parseDouble(col17.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
										if(Double.parseDouble(col21.toString()) < calculatedValue){
											createFileCount++;
											strChangeColor += "Y";
										}else{
											strChangeColor += "N";
										}
									}*/
									if(rpu.valueOfTypeOfStmt.equalsIgnoreCase("Correction") && rpu.strAnnexIColValue.charAt(j - 2) == 'F'){
										strChangeColor += "N";
									}else if(rpu.valueOfTypeOfStmt.equalsIgnoreCase("Correction") && (mode.equalsIgnoreCase("--Select--") || mode.equalsIgnoreCase("PAN UPDATE"))){
										strChangeColor += "N";
									}else{
										col17 = model1.getValueAt(j, 17);
										col21 = model1.getValueAt(j, 21);
										if(rpu.formNumber.equals("26Q") || rpu.formNumber.equals("27Q")){
											col28Or29 = model1.getValueAt(j, 28);
										}else if(rpu.formNumber.equals("27EQ")){
											col28Or29 = model1.getValueAt(j, 29);
										}
										//rpu 3.1 start calculation of total tds	correction																												
										if(rpu.formNumber.equals("26Q") ){
											if(model1.getValueAt(j, 31) !=	null && !"".equals(model1.getValueAt(j, 31)))
											{
													col31Or40 = model1.getValueAt(j, 31);
											}
										}else if(rpu.formNumber.equals("27Q")){
											if(model1.getValueAt(j, 40) !=	null && !"".equals(model1.getValueAt(j, 40)))
											{
											col31Or40 = model1.getValueAt(j, 40);
											}
										}
										
										if(col31Or40 != null)
										{
											calculatedValue = (Double.parseDouble(col31Or40.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
											System.out.println("calculated value "+calculatedValue);
										}
										else	
										calculatedValue = (Double.parseDouble(col17.toString()) * Double.parseDouble(col28Or29.toString()) /100)-10;
										if(!(model1.getValueAt(j, 6).equals("4NF"))) //RPU 3.4 Observation fix
										if(Double.parseDouble(col21.toString()) < calculatedValue){
											createFileCount++;
											strChangeColor += "Y";
											updatedRec = j;
										}else{
											strChangeColor += "N";
										}
									}
								}
								if(createFileCount > 0){
									rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
									JOptionPane.showMessageDialog(null,"Total TDS/TCS amount mentioned for deductees/collectees are not as per rate of deduction provided in the statement. Same are marked in red color.");
									rpu.pointToCell_Annex1(updatedRec, 19);
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(17)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(18)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(19)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
								}else{
									rpu.TabGRPU.setSelectedIndex(rpu.BATCH_TAB_INDEX);
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(17)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(18)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									rpu.jTableTransacDetails1
									.getColumnModel()
									.getColumn(19)
									.setCellRenderer(
											new GRPUTableCellEditorTDSValue(
													"Anne1", selYear_ann1_colour,
													next_year_ann1_colour, rpu.formNumber,
													true, strChangeColor,false));
									showCreateFileDialog(ls,true,"C");
								}
							}else{
								showCreateFileDialog(ls,true,"C");
							}
					 }else{
						 showCreateFileDialog(ls,true,"C");
					 }
					 /*********************************************************************************************************/
				  }
				}catch(Exception e1 ){
					//System.out.println("I am the fool");
					e1.printStackTrace();
				}
				//************************************
		
		}
		else if(!CorrectionFlag)
		{
			rpu.grpu.getMessage("Please make the required changes in the regular file for creating correction statement");
		}

		

	}

	
	ArrayList<Integer> ChallanList = new ArrayList<Integer>();
	ArrayList<Integer> ChallanList_Specific = new ArrayList<Integer>();

	
	ArrayList<Integer> Annexure_I_List = new ArrayList<Integer>();
	ArrayList<Integer> Annexure_II_List = new ArrayList<Integer>();
	
	ArrayList<Integer> ChallanUpdationIndicatorList = new ArrayList<Integer>();
	

	boolean corrIsError = false;

	public ArrayList<Object> EvaluateCorrectionType(FileAppender FA) {
		ArrayList<Object> ls = new ArrayList<Object>();
		
		ls.add("added for count");
	

		int challancount = new Integer(rpu.ChallanCount) + 1;
		Integer DDCount = new Integer(model1.getRowCount() - 2);
		Integer SalaryCount = 0;
		
		
		if(rpu.formNumber.equalsIgnoreCase("24Q") && rpu.quarter.equalsIgnoreCase("Q4"))
		{
			if(model2 !=  null)
			{
				SalaryCount = (new Integer(model2.getRowCount() - 2));
			}
		}
		
		

		//StringBuilder sb = new StringBuilder();

		
		
		GenerateChallanCorrectionList(challancount,"UPDATE");
		
		// For C1 -- Start//
		
		
		if (rpu.updateDD != null
				&& !rpu.updateDD.equalsIgnoreCase("")
				&& !rpu.updateDD.equalsIgnoreCase("0")
				&& ChallanList.size() == 0 && GenerateAnnexure_I_List_Update(DDCount).size() == 0) {
			BH_Count++;
		//	correctiontype+="#";
			rpu.ChallanCount = "0";
			BHBean bh = FA._BHAppenderCorrection(ls, "C1",null,BH_Count,null);
//			corrval.validationsBH(rpu); // ## Newly added for correction Ver1.2
			ls.add(bh.toString());
			/*sb.append("\n");*/

			//System.out.println("And the Correction BH String is " + bh.toString());
			CorrectionFlag = true;

		} 
		
		// For C1 -- END//
		
		Annexure_I_List.clear();
		
		// For C5 -- Start//
		
				if((GenerateAnnexure_I_List_PANUpdate(DDCount).size() != 0) | (rpu.formNumber.equalsIgnoreCase("24Q") && rpu.quarter.equalsIgnoreCase("Q4") && GenerateAnnexure_II_List(SalaryCount, "PAN UPDATE").size() != 0))
				{
					BH_Count++;
				//correctiontype+="#";
					ChallanList_Generator(); 			 // method called to create the New challan c5 list
					
					rpu.ChallanCount = new Integer(ChallanList_Specific.size()).toString();  // size of the various challan that are there 
					
					BHBean bh = FA._BHAppenderCorrection(ls, "C5",Annexure_II_List,BH_Count,ChallanList_Specific);
//					corrval.validationsBH(rpu); // ## Newly added for correction Ver1.2
					ls.add(bh.toString());
					//sb.append("\n");
					
					CDBean cd = null;
					DDBean dd = null;
					ArrayList<Integer> ddList = new ArrayList<Integer>();

					for (Integer i : ChallanList_Specific) 
					{
						
						ddList = DD_Counter(i);
						
						cd = FA._CDAppenderCorrection(ls, i+1, ddList.size(),"C5",null,BH_Count);
						corrIsError = corrval.validationsCD(rpu, i+1); // ## Newly developed for corretion Ver1.2
						if(corrIsError)
						{
							break;
						}
						//System.out.println("Only CD Strings : " + cd.toString());

						ls.add(cd);
						//sb.append("\n");
						 
						for( Integer inneri : ddList)
						{
							dd = FA._DDAppenderCorrection(ls, inneri, cd,"C5",BH_Count);
							corrIsError = corrval.validationDD(rpu,inneri); //## Newly added for correction Ver1.2
							
							if(corrIsError)
							{
								break;
							}
							System.out.println("Only DD Strings : " + dd.toString());

							ls.add(dd);
						/*	sb.append("\n");*/
						}
			
					}
					
					// FOR Annexure 2 //
					
					SDBean sd = null;
					
					for (Integer i : Annexure_II_List) {
					
						sd = FA._SDAppenderCorrection(ls, i,BH_Count);
						corrIsError = corrval.validationsSD(rpu,i); //## Newly developed for correction Ver1.2
						
						if(corrIsError)
						{
							break;
						}
						
						ls.add(sd);

						/*sb.append("\n");*/

					//	System.out.println("HI c6ACount is " + FA.c6ACount);
					//	System.out.println("HI S16Count is " + FA.S16Count);
						int serialnumber = 0;
						for (Integer inneri : FA.S16Count) {
							serialnumber++;
							S16Bean s16 = FA._S16Appender(ls, BH_Count,sd, inneri, i,
									serialnumber);

							ls.add(s16);

							/*sb.append("\n");*/

						}

						serialnumber = 0;
						
						//RPU 2.9 start
						C6ABean c6A = null;
						
						FA.c6ACount_counter=0;FA.c6aString_counter=0;
							for(FA.c6aString_counter=0;(FA.c6aString_counter<FA.c6aString.length && FA.c6ACount_counter<FA.c6ACount.size());FA.c6aString_counter++)
							{
								serialnumber++;										
								c6A = FA._C6Appender(ls, BH_Count, sd, i, serialnumber);	

								if (!(
										(          (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals(""))
												&& (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))
												&& (c6A.getQuaamountunderChapterVIA().equals("0.00") || c6A.getQuaamountunderChapterVIA().equals(""))
												)						// to handle others,80G,80TTA ka all 3 "0.00" values
												|| (     
														(c6A.getChapterVIASectionID().equals("80CCG")        && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
														|| (c6A.getChapterVIASectionID().equals("80CCE") && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
														|| (c6A.getChapterVIASectionID().equals("80CCF") && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
														)              // to handle 80CCG,80CCE,80CCF ka only deductable "0.00" values  
														||(
																(c6A.getChapterVIASectionID().equals("80C")          && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
																|| (c6A.getChapterVIASectionID().equals("80CCC")     && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
																|| (c6A.getChapterVIASectionID().equals("80CCD(1)")  && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
																|| (c6A.getChapterVIASectionID().equals("80CCD(1B)") && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
																|| (c6A.getChapterVIASectionID().equals("80CCD(2)")  && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
																|| (c6A.getChapterVIASectionID().equals("80D")       && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
																|| (c6A.getChapterVIASectionID().equals("80E")       && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
																)        // to handle remaining... only ded,grs "0.00" values  

										)
										)
								ls.add(c6A);
								else 
									serialnumber--;
							}																							
							//RPU 2.9 end
					}
					
					CorrectionFlag = true;
							
				}
				
				// For C5 -- END//
				
				Annexure_I_List.clear();
				
				System.out.println("DDCount" + DDCount);
				
				GenerateAnnexure_I_List_Update(DDCount);  // Generate the array list for Deductor Details for Update i.e C2
		
		
		// For C2 -- START//
		
		if (!corrIsError && ChallanList.size() != 0) {
				
				ArrayList<Object> sb_BH = new ArrayList<Object>();  // Temporary string to handle Challan Count in BH
				ArrayList<Object> sb_CD = new ArrayList<Object>();
				ArrayList<Integer> challan_List_temp = new ArrayList<Integer>();// Temporary list added for batch total issue
				BH_Count++;
			//	correctiontype+="C2";
				rpu.ChallanCount = new Integer(ChallanList.size()).toString();
				
				sb_BH.addAll(ls);  //Copies all element of ls int sb_bh
			
				
		
				
				BHBean bh = FA._BHAppenderCorrection(sb_BH, "C2",null,BH_Count,ChallanList);
//				corrval.validationsBH(rpu); // ## Newly added for correction Ver1.2
				sb_BH.add(bh.toString());
				//sb_BH.append("\n");
	
				
				int ddcount = 0;
	
				CDBean cd = null;
				Boolean C2Indicator = false;
				
	
				for (Integer i : ChallanList) {
					
					if(!isC3Correction(i))
					{
						challan_List_temp.add(i);
						cd = FA._CDAppenderCorrection(sb_BH, i, ddcount,"C2",null,BH_Count);
						corrIsError = corrval.validationsCD(rpu, i); // ## Newly developed for corretion Ver1.2
						
						if(corrIsError)
						{
							break;
						}
						
						System.out.println("Only CD Strings for I is: " + i);
	
						sb_CD.add(cd);
						/*sb_CD.append("\n");*/
						sb_BH.add(cd);  // added to solve line number problem
						C2Indicator = true;
					}
					else
					{
						rpu.ChallanCount = String.valueOf(new Integer(rpu.ChallanCount) - 1);
					}
	
	
				}
				
				
				
				if(C2Indicator)
				{
					bh = FA._BHAppenderCorrection(ls, "C2",null,BH_Count,challan_List_temp);
//					corrval.validationsBH(rpu); // ## Newly added for correction Ver1.2
					ls.add(bh.toString());
					/*sb.append("\n");*/
					
					ls.addAll(sb_CD);// append final Cd String 
					//sb.append("\n");
				}
				else
				{
					BH_Count--;
				}
				
				CorrectionFlag = true;
	
			}
		
		// For C2 -- END//
		
		
		// For C3 -- START//
		
		
		if (!corrIsError && Annexure_I_List.size() != 0 ) 
		{
			//System.out.println("Correction type: "+correctiontype.substring(correctiontype.length()-2,correctiontype.length()));
		/*	if(correctiontype!=null && !correctiontype.equals("") && ( !"C2".equals(correctiontype.substring(correctiontype.length()-2,correctiontype.length())))) //Added newly by Akansha for correction Ver1.2
			BH_Count++;
			else if(correctiontype.length()==0 && correctiontype.equals(""))*/
				BH_Count++;
				
			ChallanList_Generator(); 			 // method called to create the New challan c3 list
			
			rpu.ChallanCount = new Integer(ChallanList_Specific.size()).toString();  // size of the various challan that are there 
			
			BHBean bh = FA._BHAppenderCorrection(ls, "C3",null,BH_Count,ChallanList_Specific);
//			corrval.validationsBH(rpu); // ## Newly added for correction Ver1.2
			ls.add(bh.toString());
			/*sb.append("\n");*/
			
			CDBean cd = null;
			DDBean dd = null;
			ArrayList<Integer> ddList = new ArrayList<Integer>();

			for (Integer i : ChallanList_Specific) 
			{
				
				ddList = DD_Counter(i);
				
				cd = FA._CDAppenderCorrection(ls, i+1, ddList.size(),"C3",ChallanUpdationIndicatorList,BH_Count);  //Logic Added for Setting Challan UPDATION Indicator
				corrIsError = corrval.validationsCD(rpu, i+1); // ## Newly developed for corretion Ver1.2
				
				if(corrIsError)
				{
					break;
				}
				
				//System.out.println("Only CD Strings : " + cd.toString());

				ls.add(cd);
				/*sb.append("\n");*/
				// System.out.println("DDList Size: "+ ddList.size());
				for( Integer inneri : ddList)
				{
					dd = FA._DDAppenderCorrection(ls, inneri, cd, "C3",BH_Count);
					corrIsError = corrval.validationDD(rpu,inneri); //## Newly added for correction Ver1.2
					//System.out.println("Only DD Strings : " + dd.toString());
					
					if(corrIsError)
					{
						break;
					}

					ls.add(dd);
					/*sb.append("\n");*/
				}
	
			}
			CorrectionFlag = true;
			
		}
		
		// For C3 -- END//
		
		
		// For C4 -- START//
		
		if(!corrIsError && rpu.formNumber.equalsIgnoreCase("24Q") && rpu.quarter.equalsIgnoreCase("Q4") && GenerateAnnexure_II_List(SalaryCount, "ADD","Delete").size() != 0) //for Update i.e C4
		{
			rpu.ChallanCount = "0";
			BH_Count++;
			
			BHBean bh = FA._BHAppenderCorrection(ls, "C4",Annexure_II_List,BH_Count,null);
//			corrval.validationsBH(rpu); // ## Newly added for correction Ver1.2
			ls.add(bh.toString());
			/*sb.append("\n");*/
			
			SDBean sd = null;
			
			for (Integer i : Annexure_II_List) {

				sd = FA._SDAppenderCorrection(ls, i,BH_Count);
				
				corrIsError = corrval.validationsSD(rpu,i); //## Newly developed for correction Ver1.2
				
				if(corrIsError)
				{
					break;
				}
				
				ls.add(sd);

				/*sb.append("\n");*/

				//System.out.println("HI c6ACount is " + FA.c6ACount);
				//System.out.println("HI S16Count is " + FA.S16Count);
				int serialnumber = 0;
				for (Integer inneri : FA.S16Count) {
					serialnumber++;
					S16Bean s16 = FA._S16Appender(ls,BH_Count,sd, inneri, i,
							serialnumber);

					ls.add(s16);

					/*sb.append("\n");*/

				}

				/*serialnumber = 0;
				for (Integer inneri : FA.c6ACount) {
					serialnumber++;
					//RPU 2.9 start
					//C6ABean c6A = FA._C6Appender(ls,BH_Count, sd, inneri, i,serialnumber);

					//ls.add(c6A);

					
				}
							
*/
				serialnumber = 0;
				
				//RPU 2.9 start
				C6ABean c6A = null;
				
				FA.c6ACount_counter=0;FA.c6aString_counter=0;
					for(FA.c6aString_counter=0;(FA.c6aString_counter<FA.c6aString.length && FA.c6ACount_counter<FA.c6ACount.size());FA.c6aString_counter++)
					{
						serialnumber++;										
						c6A = FA._C6Appender(ls, BH_Count, sd, i, serialnumber);	

						if (!(
								(          (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals(""))
										&& (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))
										&& (c6A.getQuaamountunderChapterVIA().equals("0.00") || c6A.getQuaamountunderChapterVIA().equals(""))
										)						// to handle others,80G,80TTA ka all 3 "0.00" values
										|| (     
												(c6A.getChapterVIASectionID().equals("80CCG")        && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
												|| (c6A.getChapterVIASectionID().equals("80CCE") && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
												|| (c6A.getChapterVIASectionID().equals("80CCF") && (c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")))
												)              // to handle 80CCG,80CCE,80CCF ka only deductable "0.00" values  
												||(
														(c6A.getChapterVIASectionID().equals("80C")          && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCC")     && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCD(1)")  && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCD(1B)") && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80CCD(2)")  && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80D")       && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														|| (c6A.getChapterVIASectionID().equals("80E")       && ((c6A.getDedamountunderChapterVIA().equals("0.00") || c6A.getDedamountunderChapterVIA().equals("")) && (c6A.getGrsamountunderChapterVIA().equals("0.00") || c6A.getGrsamountunderChapterVIA().equals(""))))
														)        // to handle remaining... only ded,grs "0.00" values  

								)
								)
						ls.add(c6A);
						else 
							serialnumber--;
					}																							
					//RPU 2.9 end
			}
			CorrectionFlag = true;
			
		}
		
		
		// For C4 -- END//
		

		// For C9 -- Start //
		
		if(GenerateChallanCorrectionList(challancount,"ADD").size() != 0 && !corrIsError)
		{
			BH_Count++;
			rpu.ChallanCount = new Integer(ChallanList.size()).toString();
			
			BHBean bh = FA._BHAppenderCorrection(ls, "C9",null,BH_Count,ChallanList);
//			corrval.validationsBH(rpu); // ## Newly added for correction Ver1.2
			ls.add(bh.toString());
			/*sb.append("\n");*/
			
			CDBean cd = null;
			ArrayList<Integer> ddList = new ArrayList<Integer>();
			
			for(Integer i : ChallanList)
			{
				
				ddList = DD_Counter(i);
				
				cd = FA._CDAppenderCorrection(ls,i,ddList.size(),"C9",ChallanList,BH_Count);
				corrIsError = corrval.validationsCD(rpu, i); //## Newly added for correction Ver1.2 by Akansha
				System.out.println("Only CD Strings : " + cd.toString());

				ls.add(cd);
				/*sb.append("\n");*/

				// Start of DD Record for a particular CD //

				for (Integer inneri : FA.li) {

					DDBean dd;

	/*				Integer DDCount = new Integer(model1.getRowCount() - 2);

					DDCount = DDCount + 1;*/

					dd = FA._DDAppenderCorrection(ls, inneri, cd, "C9",BH_Count);
					corrIsError = corrval.validationDD(rpu,inneri); //## Newly added for correction Ver1.2
					
					if(corrIsError)
					{
						break;
					}
					
				//	System.out.println("Only DD Strings : " + dd.toString());

					ls.add(dd);
					/*sb.append("\n");*/

					// End of DD Record for a particular CD.
				}

				/*
				 * cd.setTDSTCSIncomeTax(""); cd.setTDSTCSCess("");
				 * cd.setTDSTCSSurcharge("");
				 */

			
				
			}
			
			CorrectionFlag = true;
			
		}
		
		// For C9 -- END //
		
		return ls;

	}


//=================================================***********************HELPER METHODS STARTS******************************===============================================
	
	
	public ArrayList<Integer> GenerateChallanCorrectionList(int challancount,String Comparison) {
		ChallanList.clear();
		
		for (int i = 2; i <= challancount; i++) {

			if (model.getValueAt(i, 1) != null
					&& model.getValueAt(i, 1).toString().length() != 0
					&& !model.getValueAt(i, 1).toString().equalsIgnoreCase("--Select--") 
					&& model.getValueAt(i, 1).toString().equalsIgnoreCase(Comparison)) {

				ChallanList.add(i);

			}

		}

		Collections.sort(ChallanList);
		
		
		return ChallanList;

	}
	
	
	public ArrayList<Integer> GenerateAnnexure_I_List_Update(int DDCount) { 
		Annexure_I_List.clear();
		DDCount = DDCount +1 ;
		
		for (int i = 2; i <= DDCount; i++) {

			Integer challanNumber = new Integer(model1.getValueAt(i, 1).toString()) + 1;
			if (model1.getValueAt(i, 2) !=  null && 
				!model1.getValueAt(i, 2).toString().equalsIgnoreCase("") &&
				( (model1.getValueAt(i, 2).toString().equalsIgnoreCase("UPDATE") ||  (model1.getValueAt(i, 2).toString().equalsIgnoreCase("ADD")) && model.getValueAt(challanNumber,1)!=null && !model.getValueAt(challanNumber,1).toString().equalsIgnoreCase("") &&  !model.getValueAt(challanNumber,1).toString().equalsIgnoreCase("ADD") )) ) // 1 added because Row number is not equal to the serial number
			{
				
					Annexure_I_List.add(i);
				

			}

		}

		
		Collections.sort(Annexure_I_List);
		
		return Annexure_I_List;

	}
	
	
	public ArrayList<Integer> GenerateAnnexure_I_List_PANUpdate(int DDCount) {  //Generalized method for generating Annexure 1 list for update as well as pan update
		Annexure_I_List.clear();
		
		DDCount = DDCount +1 ;
		
		for (int i = 2; i <= DDCount; i++) {

			
			if ((model1.getValueAt(i, 2) !=  null && 
				!model1.getValueAt(i, 2).toString().equalsIgnoreCase("") &&
				model1.getValueAt(i, 2).toString().equalsIgnoreCase("PAN UPDATE"))
				|| 
				(model1.getValueAt(i, 2) !=  null && 
				!model1.getValueAt(i, 2).toString().equalsIgnoreCase("") && 
				model1.getValueAt(i, 14) !=  null && 
				!model1.getValueAt(i, 14).toString().equalsIgnoreCase("") &&
				model1.getValueAt(i, 2).toString().equalsIgnoreCase("UPDATE") && 
				model1.getValueAt(i, 14) !=  null && 
				!model1.getValueAt(i, 14).toString().equalsIgnoreCase("") &&
				model1.getValueAt(i, 13) !=  null && 
				!model1.getValueAt(i, 13).toString().equalsIgnoreCase("") && 
				!model1.getValueAt(i, 13).toString().equalsIgnoreCase(model1.getValueAt(i, 14).toString()) && 
				!model1.getValueAt(i, 14).toString().equalsIgnoreCase("PANAPPLIED") && 
				!model1.getValueAt(i, 14).toString().equalsIgnoreCase("PANINVALID") && 
				!model1.getValueAt(i, 14).toString().equalsIgnoreCase("PANNOTAVBL") && 
				!model1.getValueAt(i, 13).toString().equalsIgnoreCase("PANAPPLIED") && 
				!model1.getValueAt(i, 13).toString().equalsIgnoreCase("PANINVALID") && 
				!model1.getValueAt(i, 13).toString().equalsIgnoreCase("PANNOTAVBL"))) // 1 added because Row number is not equal to the serial number
			{
				
					Annexure_I_List.add(i);
				

			}

		}

		Collections.sort(Annexure_I_List);
		
		return Annexure_I_List;

	}
	
	
	public ArrayList<Integer> GenerateAnnexure_II_List(int SalaryCount, String type) {  //Generalized method for generating Annexure 2 list for update as well as pan update
		
		Annexure_II_List.clear();
		
		//System.out.println("M in Annexure_II_List");
		
		SalaryCount = SalaryCount + 1 ;
		
		for (int i = 2; i <= SalaryCount; i++) {

			
			if (model2.getValueAt(i, 2) !=  null && 
				!model2.getValueAt(i, 2).toString().equalsIgnoreCase("") &&
				model2.getValueAt(i, 2).toString().equalsIgnoreCase(type) ) // 1 added because Row number is not equal to the serial number
			{

			//	System.out.println("M in Annexure_II_List added");
				Annexure_II_List.add(i);

			}

		}

		Collections.sort(Annexure_II_List);
		
		return Annexure_II_List;

	}
	
	
	public ArrayList<Integer> GenerateAnnexure_II_List(int SalaryCount, String type1,String type2) {  //Generalized method for generating Annexure 2 list for ADD and DELETE
		
		Annexure_II_List.clear();
		
		//System.out.println("M in Annexure_II_List");
		
		SalaryCount = SalaryCount + 1 ;
		
		for (int i = 2; i <= SalaryCount; i++) {

			
			if (model2.getValueAt(i, 2) !=  null && 
				!model2.getValueAt(i, 2).toString().equalsIgnoreCase("") &&
				(model2.getValueAt(i, 2).toString().equalsIgnoreCase(type1) || model2.getValueAt(i, 2).toString().equalsIgnoreCase(type2)) ) // 1 added because Row number is not equal to the serial number
			{

			//	System.out.println("M in Annexure_II_List added");
				Annexure_II_List.add(i);

			}

		}

		Collections.sort(Annexure_II_List);
		
		return Annexure_II_List;

	}
	
	public boolean isC3Correction(Integer i) 
	{
		i = i-1;
		for(Integer j : Annexure_I_List)
		{
			if(model1.getValueAt(j, 1) !=  null && model1.getValueAt(j, 1).toString().equalsIgnoreCase(i.toString()))
			{
				ChallanUpdationIndicatorList.add(i+1);  //Logic Added for Setting Challan UPDATION Indicator  -- latish
				return true;
			}
		}
		
		Collections.sort(ChallanUpdationIndicatorList);
		return false;
	}
	
	
	public void ChallanList_Generator()
	{
		ChallanList_Specific.clear();
		for(Integer j : Annexure_I_List)
		{
			if(model1.getValueAt(j, 1) !=  null  && !ChallanList_Specific.contains(new Integer(model1.getValueAt(j, 1).toString())) )
			{
				ChallanList_Specific.add(new Integer(model1.getValueAt(j, 1).toString()));
			}
			
		}
		
		Collections.sort(ChallanList_Specific);
	}
	
	public ArrayList<Integer> DD_Counter(Integer i)
	{
		ArrayList<Integer> ddList = new ArrayList<Integer>();
		
		for(Integer j : Annexure_I_List)
		{
			
			if(model1.getValueAt(j, 1) !=  null && model1.getValueAt(j, 1).toString().equalsIgnoreCase(i.toString()))
			{
				ddList.add(j);
			}
			
		}
		
		Collections.sort(ddList);
		
		return ddList;
	}

	
	
	//=================================================***********************HELPER METHODS ENDS******************************===============================================	
	
	/*
	 * ====================================================================Code
	 * for Creating Dialogue box and Creating actual
	 * File=======================================
	 */
	

	/*public void showCreateFileDialog(StringBuilder details) {
		
		Log.tbaf_log.info("HERE  is Create File method  String" + details);
		Boolean status = false;
		File fileToSave = null;
		//JFileChooser fileChooser = new JFileChooser();
		//fileChooser.setDialogTitle("Specify a file to create");
		String Filename = rpu.formNumber+rpu.valueOfTypeOfStmt.subSequence(0, 1)+rpu.quarter;
		//fileChooser.setSelectedFile(new File(Filename));
		//int userSelection = fileChooser.showSaveDialog(null);
		try {
			//if (userSelection == JFileChooser.APPROVE_OPTION) {
				
				
				
				//fileToSave = fileChooser.getSelectedFile();
				
			//	writeCreateFile(fileToSave.getAbsolutePath() + ".txt",
				//		details.toString());
				grpumain.createCustomDialogNew(Filename,details.toString(),rpu.finyear);
				status = true;
				//JOptionPane.showMessageDialog(null,"File has been created successfully at "+fileToSave.getAbsolutePath());
				
			//}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			status = false;

		}
	}*/
	public void showCreateFileDialog(List details,boolean flag,String filetype) {
		
	//	System.out.println("--ye wala pakka--");
		Boolean status = false;
		File fileToSave = null;
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setDialogTitle("Specify a file to create");
		String Filename = rpu.formNumber+rpu.valueOfTypeOfStmt.subSequence(0, 1)+rpu.quarter;
		fileChooser.setSelectedFile(new File(Filename));
		//int userSelection = fileChooser.showSaveDialog(null);
		try {
			//if (userSelection == JFileChooser.APPROVE_OPTION) {
				
				
				
				//fileToSave = fileChooser.getSelectedFile();
				
			//	writeCreateFile(fileToSave.getAbsolutePath() + ".txt",
				//		details.toString());
				//grpumain.createCustomDialogNew(Filename,details.toString(),rpu.finyear);
			grpumain.createCustomDialogNew(Filename,details,rpu.finyear,flag,filetype);
				status = true;
				//JOptionPane.showMessageDialog(null,"File has been created successfully at "+fileToSave.getAbsolutePath());
				
			//}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			status = false;

		}
	}

	public static void writeCreateFile(String canonicalFilename, String text)
			throws IOException {
		File file = new File(canonicalFilename);
		BufferedWriter out = new BufferedWriter(new FileWriter(file));
		out.write(text);
		out.close();
	}

	/*
	 * public String CountOccurence(String str,String findStr) { int count=0;
	 * //String findStr = "\n"; int lastIndex = 0;
	 * 
	 * 
	 * while(lastIndex != -1){
	 * 
	 * lastIndex = str.indexOf(findStr,lastIndex);
	 * 
	 * if( lastIndex != -1){ count ++; lastIndex+=findStr.length(); } }
	 * 
	 * count = count+1; // added to make it next line
	 * 
	 * return (new Integer(count).toString()); }
	 * 
	 * 
	 * public String GenerateSequence() {
	 * 
	 * String sequence = new SimpleDateFormat("ddMMYYYYHHmmss").format(new
	 * Date()).toString();
	 * 
	 * return sequence; }
	 * 
	 * 
	 * public ArrayList deducteeDetails(int deducteecount, Integer position) {
	 * ArrayList<Integer> li = new ArrayList(); deducteecount++;
	 * 
	 * for(int i=2;i<=deducteecount;i++) { if(model1.getValueAt(i, 1) != null &&
	 * !(model1.getValueAt(i, 1).toString().equals(""))) {
	 * if(model1.getValueAt(i, 1).toString().equals(position.toString())) {
	 * li.add(i); } } }
	 * 
	 * 
	 * return li;
	 * 
	 * }
	 */
}
